// ===========================================================================
//	SCAPIApp.h				   1997 Spunk Cross		 All rights reserved.
// ===========================================================================

#ifndef SCAPIAPP_H
#define SCAPIAPP_H

#include "SCAPICommonIncludes.h"
#include "SCAPIMenuBar.h"


// ---------------------------------------------------------------------------
//		 SCAPIApp Class
// ---------------------------------------------------------------------------

class SCAPIApp : public LApplication
{
	friend class SCAPIWindow;

	// ===========================================================
	// === Spunk Cross API, these are the routines you can use ===
	// ===========================================================
	
		//  Constructor
		// -------------
		
	public:
	
		SCAPIApp(int*	argcP, char***	argvP);
		
		
		//  Member functions
		// ------------------
		
	public:
		
		void				AssociateMenuBar(SCAPIMenuBar*	inMenuBarP);
	
	
	protected:
	
		virtual void		ExecuteCommand(int	inCommand);
		
		virtual void		CommandStatus(	int		inCommand,
											bool	&outEnabled,
											int		&outMark,
											char*	outName			);
		
		
	// =================================
	// === Internal part, do not use ===
	// =================================
		
		//  Member functions
		// ------------------
		
	private:
		
		virtual Boolean		ObeyCommand(	CommandT	inCommand,
											void*		ioParam		);	
											
		virtual void		FindCommandStatus(	CommandT	inCommand,
												Boolean		&outEnabled,
												Boolean		&outUsesMark,
												Char16		&outMark,
												Str255		outName			);
												
		void				FreeMenuBar();
		
		virtual void		MakeMenuBar();
		
		virtual void		ProcessNextEvent();
												
												
		//  Member variables
		// ------------------
		
	private:
	
		SCAPIMenuBar*		mMenuBarP;
		long				mRefTick;
};

#endif