// ===========================================================================
//	SCAPITextField.h			1997 Spunk Cross		 All rights reserved.
// ===========================================================================

#ifndef SCAPITEXTFIELD_H
#define SCAPITEXTFIELD_H

#include "SCAPICommonIncludes.h"
#include "SCAPIWindow.h"


// ---------------------------------------------------------------------------
//		 Defines
// ---------------------------------------------------------------------------

#define SCAPITextField_default_originx			0
#define SCAPITextField_default_originy			0
#define SCAPITextField_default_width			57
#define SCAPITextField_default_height			19


// ---------------------------------------------------------------------------
//		 SCAPITextField Class
// ---------------------------------------------------------------------------

class SCAPITextField : public LEditField
{

	// ===========================================================
	// === Spunk Cross API, these are the routines you can use ===
	// ===========================================================
	
		//  Constructor - Destructor
		// --------------------------
		
	public:
	
		SCAPITextField(	SCAPIWindow*	inWindowP,
						int				inOriginx = SCAPITextField_default_originx,
						int 			inOriginy = SCAPITextField_default_originy,
						int				inWidth = SCAPITextField_default_width,
						int				inHeight = SCAPITextField_default_height	);
		
		~SCAPITextField();
		
		
		//  Member functions
		// ------------------
		
	public:
	
		void		SetMaxNumChars(int		inMaxNum);
	
		void		Set(char*	inText);
		
		char*		Get();
		
		
	// =================================
	// === Internal part, do not use ===
	// =================================
		
		//  Member functions
		// ------------------
		
	private:
	
		SPaneInfo		MakeSPaneInfo(	SCAPIWindow*	inWindowP,
										int				inOriginx,
										int				inOriginy,
										int				inWidth,
										int				inHeight	);
										
		int				CStringLength(char*	inCString);
										
										
		//  Member variables
		// ------------------
		
	private:
	
		SPaneInfo			mSPaneInfo;
};

#endif